image: registry.gitlab.com/gitlab-org/terraform-images/stable:latest

variables:
  TF_ROOT: ${CI_PROJECT_DIR}
  TF_ADDRESS: ${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/terraform/state/default
  TERRAFORM_VALIDATION_ONLY: "false"

cache:
  key: default
  paths:
    - ${TF_ROOT}/.terraform

before_script:
  - cd ${TF_ROOT}

stages:
  - init
  - validate
  - plan
  - deploy

init:
  stage: init
  script:
    - gitlab-terraform version
    - gitlab-terraform init -upgrade

validate:
  stage: validate
  script:
    - gitlab-terraform validate

plan:
  stage: plan
  script:
    - |- 
      if [[ $TERRAFORM_VALIDATION_ONLY == "true" ]]; then
        echo "Skipping since TERRAFORM_VALIDATION_ONLY is set to true"
        exit 0
      fi
    - gitlab-terraform plan
    - gitlab-terraform plan-json
  artifacts:
    name: plan
    paths:
      - ${TF_ROOT}/plan.cache
    reports:
      terraform: ${TF_ROOT}/plan.json

apply:
  stage: deploy
  environment:
    name: production
  script:
    - |- 
      if [[ $TERRAFORM_VALIDATION_ONLY == "true" ]]; then
        echo "Skipping since TERRAFORM_VALIDATION_ONLY is set to true"
        exit 0
      fi
    - gitlab-terraform apply
  when: manual
  only:
    - main

destroy-plan:
  stage: plan
  script:
    - |- 
      if [[ $TERRAFORM_VALIDATION_ONLY == "true" ]]; then
        echo "Skipping since TERRAFORM_VALIDATION_ONLY is set to true"
        exit 0
      fi
    - gitlab-terraform plan -destroy
  artifacts:
    name: plan
    paths:
      - ${TF_ROOT}/plan.cache
    reports:
      terraform: ${TF_ROOT}/plan.json
  rules:
    - if: $TERRAFORM_DESTROY == "true"
      when: manual

destroy-apply:
  stage: deploy
  environment:
    name: production
  script:
    - |- 
      if [[ $TERRAFORM_VALIDATION_ONLY == "true" ]]; then
        echo "Skipping since TERRAFORM_VALIDATION_ONLY is set to true"
        exit 0
      fi
    - gitlab-terraform apply -destroy
  rules:
    - if: $TERRAFORM_DESTROY == "true"
      when: manual
